Index: squid/src/dns_internal.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/dns_internal.c,v
retrieving revision 1.1.1.1.4.1.4.2
retrieving revision 1.1.1.1.4.1.4.3
diff -u -r1.1.1.1.4.1.4.2 -r1.1.1.1.4.1.4.3
--- squid/src/dns_internal.c	16 Apr 2000 23:59:17 -0000	1.1.1.1.4.1.4.2
+++ squid/src/dns_internal.c	3 May 2000 19:22:27 -0000	1.1.1.1.4.1.4.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: dns_internal.c,v 1.1.1.1.4.1.4.2 2000/04/16 23:59:17 hno Exp $
+ * $Id: dns_internal.c,v 1.1.1.1.4.1.4.3 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 78    DNS lookups; interacts with lib/rfc1035.c
  * AUTHOR: Duane Wessels
@@ -44,8 +44,6 @@
 #define DOMAIN_PORT 53
 #endif
 
-#define IDNS_MAX_TRIES 20
-
 typedef struct _idns_query idns_query;
 typedef struct _ns ns;
 
@@ -143,13 +141,13 @@
 	t = strtok(buf, w_space);
 	if (NULL == t)
 	    continue;
-	if (strcasecmp(t, "nameserver"))
-	    continue;
-	t = strtok(NULL, w_space);
-	if (t == NULL)
-	    continue;;
-	debug(78, 1) ("Adding nameserver %s from %s\n", t, _PATH_RESOLV_CONF);
-	idnsAddNameserver(t);
+	if (strcasecmp(t, "nameserver") == 0) {
+	    t = strtok(NULL, w_space);
+	    if (t == NULL)
+		continue;;
+	    debug(78, 1) ("Adding nameserver %s from %s\n", t, _PATH_RESOLV_CONF);
+	    idnsAddNameserver(t);
+	}
     }
     fclose(fp);
 }
@@ -207,21 +205,24 @@
     assert(nns > 0);
     assert(q->lru.next == NULL);
     assert(q->lru.prev == NULL);
+try_again:
     ns = q->nsends % nns;
     x = comm_udp_sendto(DnsSocket,
 	&nameservers[ns].S,
 	sizeof(nameservers[ns].S),
 	q->buf,
 	q->sz);
+    q->nsends++;
+    q->sent_t = current_time;
     if (x < 0) {
 	debug(50, 1) ("idnsSendQuery: FD %d: sendto: %s\n",
 	    DnsSocket, xstrerror());
+	if (q->nsends % nns != 0)
+	    goto try_again;
     } else {
 	fd_bytes(DnsSocket, x, FD_WRITE);
 	commSetSelect(DnsSocket, COMM_SELECT_READ, idnsRead, NULL, 0);
     }
-    q->nsends++;
-    q->sent_t = current_time;
     nameservers[ns].nqueries++;
     dlinkAdd(q, &q->lru, &lru_list);
     idnsTickleQueue();
@@ -353,13 +354,13 @@
     event_queued = 0;
     for (n = lru_list.tail; n; n = p) {
 	q = n->data;
-	if (tvSubDsec(q->sent_t, current_time) < 5.0)
+	if (tvSubDsec(q->sent_t, current_time) < Config.Timeout.idns_retransmit * ( 1 << q->nsends % nns))
 	    break;
 	debug(78, 3) ("idnsCheckQueue: ID %#04x timeout\n",
 	    q->id);
 	p = n->prev;
 	dlinkDelete(&q->lru, &lru_list);
-	if (q->nsends < IDNS_MAX_TRIES) {
+	if (tvSubDsec(q->start_t, current_time) < Config.Timeout.idns_query) {
 	    idnsSendQuery(q);
 	} else {
 	    int v = cbdataValid(q->callback_data);
Index: squid/src/enums.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/enums.h,v
retrieving revision 1.1.1.3.8.2
retrieving revision 1.1.1.3.8.3
diff -u -r1.1.1.3.8.2 -r1.1.1.3.8.3
--- squid/src/enums.h	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.2
+++ squid/src/enums.h	3 May 2000 19:22:27 -0000	1.1.1.3.8.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: enums.h,v 1.1.1.3.8.2 2000/04/16 23:59:17 hno Exp $
+ * $Id: enums.h,v 1.1.1.3.8.3 2000/05/03 19:22:27 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -108,17 +108,20 @@
     ACL_MY_PORT,
 #if USE_IDENT
     ACL_IDENT,
+    ACL_IDENT_REGEX,
 #endif
     ACL_PROTO,
     ACL_METHOD,
     ACL_BROWSER,
     ACL_PROXY_AUTH,
+    ACL_PROXY_AUTH_REGEX,
     ACL_SRC_ASN,
     ACL_DST_ASN,
     ACL_SRC_ARP,
     ACL_SNMP_COMMUNITY,
     ACL_NETDB_SRC_RTT,
     ACL_MAXCONN,
+    ACL_REQ_MIME_TYPE,
     ACL_ENUM_MAX
 } squid_acl;
 
@@ -506,7 +509,6 @@
     MEM_ACL_NAME_LIST,
     MEM_ACL_PROXY_AUTH_USER,
     MEM_ACL_TIME_DATA,
-    MEM_AIO_RESULT_T,
     MEM_CACHEMGR_PASSWD,
 #if USE_CACHE_DIGESTS
     MEM_CACHE_DIGEST,
@@ -520,7 +522,6 @@
 #if USE_CACHE_DIGESTS
     MEM_DIGEST_FETCH_STATE,
 #endif
-    MEM_DISK_BUF,
     MEM_DLINK_LIST,
     MEM_DLINK_NODE,
     MEM_DNSSERVER_T,
@@ -570,8 +571,10 @@
 #if USE_CACHE_DIGESTS
     MEM_PEER_DIGEST,
 #endif
+#if USE_ICMP
     MEM_PINGERECHODATA,
     MEM_PINGERREPLYDATA,
+#endif
     MEM_PS_STATE,
     MEM_REFRESH_T,
     MEM_RELIST,
@@ -657,12 +660,3 @@
     NETDB_EX_RTT,
     NETDB_EX_HOPS
 };
-
-typedef enum {
-    SWAPDIR_UFS,
-    SWAPDIR_ASYNCUFS,
-#if USE_DISKD
-    SWAPDIR_DISKD,
-#endif
-    SWAPDIR_MAX
-} swapdir_t;
Index: squid/src/event.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/event.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/event.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/event.c	3 May 2000 19:22:27 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: event.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: event.c,v 1.1.1.3.8.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 41    Event Processing
  * AUTHOR: Henrik Nordstrom
@@ -191,6 +191,7 @@
 {
     struct ev_entry *event;
     while ((event = tasks)) {
+	tasks = event->next;
 	if (NULL != event->arg)
 	    cbdataUnlock(event->arg);
 	memFree(event, MEM_EVENT);
Index: squid/src/fd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fd.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/fd.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/fd.c	3 May 2000 19:22:27 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: fd.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: fd.c,v 1.1.1.3.8.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 51    Filedescriptor Functions
  * AUTHOR: Duane Wessels
@@ -95,12 +95,6 @@
 {
     fde *F = &fd_table[fd];
     assert(fd >= 0);
-#if USE_ASYNC_IO
-    if (F->flags.closing) {
-	/* Reuse of a closed FD before we have noticed it is closed */
-	fd_close(fd);
-    }
-#endif
     if (F->flags.open) {
 	debug(51, 1) ("WARNING: Closing open FD %4d\n", fd);
 	fd_close(fd);
Index: squid/src/filemap.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/filemap.c,v
retrieving revision 1.1.1.2.8.1
retrieving revision 1.1.1.2.8.2
diff -u -r1.1.1.2.8.1 -r1.1.1.2.8.2
--- squid/src/filemap.c	16 Apr 2000 23:59:17 -0000	1.1.1.2.8.1
+++ squid/src/filemap.c	3 May 2000 19:22:27 -0000	1.1.1.2.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: filemap.c,v 1.1.1.2.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: filemap.c,v 1.1.1.2.8.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 8     Swap File Bitmap
  * AUTHOR: Harvest Derived
@@ -133,7 +133,7 @@
     for (bit = 0; bit < BITS_IN_A_LONG; bit++) {
 	suggestion = ((unsigned long) word << LONG_BIT_SHIFT) | bit;
 	if (!file_map_bit_test(fm, suggestion)) {
-	    return file_map_bit_set(fm, suggestion);
+	    return suggestion;
 	}
     }
     debug(8, 3) ("growing from file_map_allocate\n");
Index: squid/src/forward.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/forward.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/forward.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/forward.c	3 May 2000 19:22:27 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: forward.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: forward.c,v 1.1.1.3.8.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 17    Request Forwarding
  * AUTHOR: Duane Wessels
@@ -133,13 +133,20 @@
 	    fwdState->n_tries,
 	    (int) (squid_curtime - fwdState->start));
 	if (fwdState->servers->next) {
-	    /* cycle */
+	    /* use next, or cycle if origin server isn't last */
 	    FwdServer *fs = fwdState->servers;
-	    FwdServer **T;
+	    FwdServer **T, *T2 = NULL;
 	    fwdState->servers = fs->next;
-	    for (T = &fwdState->servers; *T; T = &(*T)->next);
-	    *T = fs;
-	    fs->next = NULL;
+	    for (T = &fwdState->servers; *T; T2=*T, T = &(*T)->next);
+	    if (T2 && T2->peer)  {
+		/* cycle */
+		*T = fs;
+		fs->next = NULL;
+	    } else {
+		/* Use next. The last "direct" entry is retried multiple times */
+		fwdState->servers = fs->next;
+		fwdServerFree(fs);
+	    }
 	}
 	/* use eventAdd to break potential call sequence loops */
 	eventAdd("fwdConnectStart", fwdConnectStart, fwdState, 0.0, 0);
@@ -182,12 +189,20 @@
 	err->request = requestLink(request);
 	fwdFail(fwdState, err);
 	if (fs->peer)
-	    peerCheckConnectStart(fs->peer);
+	    peerConnectFailed(fs->peer);
 	comm_close(server_fd);
     } else {
 	debug(17, 3) ("fwdConnectDone: FD %d: '%s'\n", server_fd, storeUrl(fwdState->entry));
+	if (fs->peer)
+	    hierarchyNote(&fwdState->request->hier, fs->code, fs->peer->host);
+	else if (Config.onoff.log_ip_on_direct)
+	    hierarchyNote(&fwdState->request->hier, fs->code, fd_table[server_fd].ipaddr);
+	else
+	    hierarchyNote(&fwdState->request->hier, fs->code, request->host);
 	fd_note(server_fd, storeUrl(fwdState->entry));
 	fd_table[server_fd].uses++;
+	if (fs->peer)
+	    peerConnectSucceded(fs->peer);
 	fwdDispatch(fwdState);
     }
     current = NULL;
@@ -211,7 +226,7 @@
 	 */
 	if (fwdState->servers)
 	    if (fwdState->servers->peer)
-		peerCheckConnectStart(fwdState->servers->peer);
+		peerConnectFailed(fwdState->servers->peer);
     }
     comm_close(fd);
 }
@@ -235,12 +250,16 @@
 	port = fs->peer->http_port;
 	ctimeout = fs->peer->connect_timeout > 0 ? fs->peer->connect_timeout
 	    : Config.Timeout.peer_connect;
+    } else if (fwdState->request->flags.accelerated &&
+	    	Config.Accel.single_host && Config.Accel.host) {
+	host = Config.Accel.host;
+	port = Config.Accel.port;
+	ctimeout = Config.Timeout.connect;
     } else {
 	host = fwdState->request->host;
 	port = fwdState->request->port;
 	ctimeout = Config.Timeout.connect;
     }
-    hierarchyNote(&fwdState->request->hier, fs->code, host);
     if ((fd = pconnPop(host, port)) >= 0) {
 	debug(17, 3) ("fwdConnectStart: reusing pconn FD %d\n", fd);
 	fwdState->server_fd = fd;
Index: squid/src/ftp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ftp.c,v
retrieving revision 1.1.1.3.4.1.4.1
retrieving revision 1.1.1.3.4.1.4.2
diff -u -r1.1.1.3.4.1.4.1 -r1.1.1.3.4.1.4.2
--- squid/src/ftp.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.4.1.4.1
+++ squid/src/ftp.c	3 May 2000 19:22:27 -0000	1.1.1.3.4.1.4.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ftp.c,v 1.1.1.3.4.1.4.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: ftp.c,v 1.1.1.3.4.1.4.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 9     File Transfer Protocol (FTP)
  * AUTHOR: Harvest Derived
@@ -896,7 +896,7 @@
 	ftpListingStart(ftpState);
     }
     if (len < 0) {
-	debug(50, 1) ("ftpDataRead: read error: %s\n", xstrerror());
+	debug(50, ignoreErrno(errno) ? 3 : 1) ("ftpDataRead: read error: %s\n", xstrerror());
 	if (ignoreErrno(errno)) {
 	    commSetSelect(fd,
 		COMM_SELECT_READ,
@@ -1247,7 +1247,7 @@
     }
     debug(9, 5) ("ftpReadControlReply: FD %d, Read %d bytes\n", fd, len);
     if (len < 0) {
-	debug(50, 1) ("ftpReadControlReply: read error: %s\n", xstrerror());
+	debug(50, ignoreErrno(errno) ? 3 : 1) ("ftpReadControlReply: read error: %s\n", xstrerror());
 	if (ignoreErrno(errno)) {
 	    ftpScheduleReadControlReply(ftpState, 0);
 	} else {
@@ -1303,11 +1303,15 @@
 	xmemmove(ftpState->ctrl.buf, ftpState->ctrl.buf + bytes_used,
 	    ftpState->ctrl.offset);
     }
-    /* Find the last line of the reply message */
+    /* Move the last line of the reply message to ctrl.last_reply */
     for (W = &ftpState->ctrl.message; (*W)->next; W = &(*W)->next);
     safe_free(ftpState->ctrl.last_reply);
-    ftpState->ctrl.last_reply = (*W)->key;
-    safe_free(*W);
+    ftpState->ctrl.last_reply = xstrdup((*W)->key);
+    wordlistDestroy(W);
+    /* Copy the rest of the message to cwd_message to be printed in
+     * error messages
+     */
+    wordlistAddWl(&ftpState->cwd_message, ftpState->ctrl.message);
     debug(9, 8) ("ftpHandleControlReply: state=%d, code=%d\n", ftpState->state,
 	ftpState->ctrl.replycode);
     FTP_SM_FUNCS[ftpState->state] (ftpState);
@@ -1328,10 +1332,6 @@
 	if (ftpState->ctrl.message) {
 	    if (strstr(ftpState->ctrl.message->key, "NetWare"))
 		ftpState->flags.skip_whitespace = 1;
-	    if (ftpState->cwd_message)
-		wordlistDestroy(&ftpState->cwd_message);
-	    ftpState->cwd_message = ftpState->ctrl.message;
-	    ftpState->ctrl.message = NULL;
 	}
 	ftpSendUser(ftpState);
     } else if (code == 120) {
@@ -1385,12 +1385,6 @@
     int code = ftpState->ctrl.replycode;
     debug(9, 3) ("ftpReadPass\n");
     if (code == 230) {
-	if (ftpState->ctrl.message) {
-	    if (ftpState->cwd_message)
-		wordlistDestroy(&ftpState->cwd_message);
-	    ftpState->cwd_message = ftpState->ctrl.message;
-	    ftpState->ctrl.message = NULL;
-	}
 	ftpSendType(ftpState);
     } else {
 	ftpFail(ftpState);
@@ -1516,6 +1510,7 @@
     if (code >= 200 && code < 300) {
 	/* CWD OK */
 	ftpUnhack(ftpState);
+	/* Reset cwd_message to only include the last message */
 	if (ftpState->cwd_message)
 	    wordlistDestroy(&ftpState->cwd_message);
 	ftpState->cwd_message = ftpState->ctrl.message;
@@ -1645,6 +1640,14 @@
     int fd;
     struct sockaddr_in addr;
     socklen_t addr_len;
+    if (ftpState->request->method == METHOD_HEAD) {
+	/* Terminate here for HEAD requests */
+	ftpAppendSuccessHeader(ftpState);
+	storeTimestampsSet(ftpState->entry);
+	fwdComplete(ftpState->fwd);
+	ftpSendQuit(ftpState);
+	return;
+    }
     if (ftpState->data.fd >= 0) {
 	if (!ftpState->flags.datachannel_hack) {
 	    /* We are already connected, reuse this connection. */
@@ -2338,8 +2341,8 @@
 	err = errorCon(ERR_FTP_FAILURE, HTTP_BAD_GATEWAY);
     err->xerrno = errno;
     err->request = requestLink(ftpState->request);
-    err->ftp.server_msg = ftpState->ctrl.message;
-    ftpState->ctrl.message = NULL;
+    err->ftp.server_msg = ftpState->cwd_message;
+    ftpState->cwd_message = NULL;
     if (ftpState->old_request)
 	command = ftpState->old_request;
     else
Index: squid/src/globals.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/globals.h,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/globals.h	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/globals.h	3 May 2000 19:22:27 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: globals.h,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: globals.h,v 1.1.1.3.8.2 2000/05/03 19:22:27 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -126,10 +126,8 @@
 extern int store_hash_buckets;	/* 0 */
 extern hash_table *store_table;	/* NULL */
 #if HEAP_REPLACEMENT
-extern heap *store_heap;
 extern heap *inmem_heap;
 #else
-extern dlink_list store_list;
 #endif
 extern dlink_list ClientActiveRequests;
 extern const String StringNull;	/* { 0, 0, NULL } */
@@ -151,3 +149,8 @@
 extern request_flags null_request_flags;
 extern int store_open_disk_fd;	/* 0 */
 extern const char *SwapDirType[];
+extern storefs_entry_t *storefs_list; /* NULL */
+extern int store_swap_low;
+extern int store_swap_high;
+extern int store_pages_max;
+extern size_t store_maxobjsize;
Index: squid/src/helper.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/helper.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.8.1
diff -u -r1.1.1.3 -r1.1.1.3.8.1
--- squid/src/helper.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/helper.c	3 May 2000 19:22:27 -0000	1.1.1.3.8.1
@@ -126,17 +126,18 @@
     storeAppendPrintf(sentry, "avg service time: %d msec\n",
 	hlp->stats.avg_svc_time);
     storeAppendPrintf(sentry, "\n");
-    storeAppendPrintf(sentry, "%7s\t%7s\t%11s\t%s\t%7s\t%7s\n",
+    storeAppendPrintf(sentry, "%7s\t%7s\t%11s\t%s\t%7s\t%7s\t%7s\n",
 	"#",
 	"FD",
 	"# Requests",
 	"Flags",
 	"Time",
-	"Offset");
+	"Offset",
+	"Request");
     for (link = hlp->servers.head; link; link = link->next) {
 	srv = link->data;
 	tt = 0.001 * tvSubMsec(srv->dispatch_time, current_time);
-	storeAppendPrintf(sentry, "%7d\t%7d\t%11d\t%c%c%c%c\t%7.3f\t%7d\n",
+	storeAppendPrintf(sentry, "%7d\t%7d\t%11d\t%c%c%c%c\t%7.3f\t%7d\t%s\n",
 	    srv->index + 1,
 	    srv->rfd,
 	    srv->stats.uses,
@@ -145,7 +146,8 @@
 	    srv->flags.closing ? 'C' : ' ',
 	    srv->flags.shutdown ? 'S' : ' ',
 	    tt < 0.0 ? 0.0 : tt,
-	    (int) srv->offset);
+	    (int) srv->offset,
+	    srv->request ? log_quote(srv->request->buf) : "(none)");
     }
     storeAppendPrintf(sentry, "\nFlags key:\n\n");
     storeAppendPrintf(sentry, "   A = ALIVE\n");
@@ -179,7 +181,8 @@
 	    continue;
 	}
 	srv->flags.closing = 1;
-	comm_close(srv->rfd);
+	comm_close(srv->wfd);
+	srv->wfd = -1;
     }
 }
 
@@ -223,7 +226,7 @@
 	helperRequestFree(r);
 	srv->request = NULL;
     }
-    if (srv->wfd != srv->rfd)
+    if (srv->wfd != srv->rfd && srv->wfd != -1)
 	comm_close(srv->wfd);
     dlinkDelete(&srv->link, &hlp->servers);
     hlp->n_running--;
@@ -282,9 +285,10 @@
 	    intAverage(hlp->stats.avg_svc_time,
 	    tvSubMsec(srv->dispatch_time, current_time),
 	    hlp->stats.replies, REDIRECT_AV_FACTOR);
-	if (srv->flags.shutdown)
+	if (srv->flags.shutdown) {
 	    comm_close(srv->wfd);
-	else
+	    srv->wfd = -1;
+	} else
 	    helperKickQueue(hlp);
     } else {
 	commSetSelect(srv->rfd, COMM_SELECT_READ, helperHandleRead, srv, 0);
Index: squid/src/http.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/http.c,v
retrieving revision 1.1.1.3.4.1.4.2
retrieving revision 1.1.1.3.4.1.4.3
diff -u -r1.1.1.3.4.1.4.2 -r1.1.1.3.4.1.4.3
--- squid/src/http.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.4.1.4.2
+++ squid/src/http.c	3 May 2000 19:22:27 -0000	1.1.1.3.4.1.4.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: http.c,v 1.1.1.3.4.1.4.2 2000/04/16 23:59:17 hno Exp $
+ * $Id: http.c,v 1.1.1.3.4.1.4.3 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 11    Hypertext Transfer Protocol (HTTP)
  * AUTHOR: Harvest Derived
@@ -327,10 +327,12 @@
     if (httpState->reply_hdr == NULL)
 	httpState->reply_hdr = memAllocate(MEM_8K_BUF);
     assert(httpState->reply_hdr_state == 0);
-    hdr_len = strlen(httpState->reply_hdr);
+    hdr_len = httpState->reply_hdr_size;
     room = 8191 - hdr_len;
-    strncat(httpState->reply_hdr, buf, room < size ? room : size);
+    memcpy(httpState->reply_hdr + hdr_len, buf, room < size ? room : size);
     hdr_len += room < size ? room : size;
+    httpState->reply_hdr[hdr_len] = '\0';
+    httpState->reply_hdr_size = hdr_len;
     if (hdr_len > 4 && strncmp(httpState->reply_hdr, "HTTP/", 5)) {
 	debug(11, 3) ("httpProcessReplyHeader: Non-HTTP-compliant header: '%s'\n", httpState->reply_hdr);
 	httpState->reply_hdr_state += 2;
@@ -340,9 +342,17 @@
     t = httpState->reply_hdr + hdr_len;
     /* headers can be incomplete only if object still arriving */
     if (!httpState->eof) {
-	size_t k = headersEnd(httpState->reply_hdr, 8192);
-	if (0 == k)
-	    return;		/* headers not complete */
+	size_t k = headersEnd(httpState->reply_hdr, hdr_len);
+	if (0 == k) {
+	    if (hdr_len >= 8191 || room == 0) {
+		debug(11, 3) ("httpProcessReplyHeader: Too large HTTP header: '%s'\n", httpState->reply_hdr);
+		httpState->reply_hdr_state += 2;
+		reply->sline.status = HTTP_INVALID_HEADER;
+		return;
+	    } else {
+		return;		/* headers not complete */
+	    }
+	}
 	t = httpState->reply_hdr + k;
     }
     *t = '\0';
@@ -886,7 +896,8 @@
     else if ((double) p->stats.n_keepalives_recv / (double) p->stats.n_keepalives_sent > 0.50)
 	httpState->flags.keepalive = 1;
     if (httpState->peer)
-	if (neighborType(httpState->peer, httpState->request) == PEER_SIBLING)
+	if (neighborType(httpState->peer, httpState->request) == PEER_SIBLING &&
+		!httpState->peer->options.allow_miss)
 	    httpState->flags.only_if_cached = 1;
     memBufDefInit(&mb);
     httpBuildRequestPrefix(req,
Index: squid/src/ipc.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ipc.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/ipc.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/ipc.c	3 May 2000 19:22:27 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ipc.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: ipc.c,v 1.1.1.3.8.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 54    Interprocess Communication
  * AUTHOR: Duane Wessels
@@ -228,14 +228,14 @@
 	    return ipcCloseAllFD(prfd, pwfd, crfd, cwfd);
     }
     if (type == IPC_UDP_SOCKET) {
-	x = send(cwfd, hello_string, strlen(hello_string), 0);
+	x = send(cwfd, hello_string, strlen(hello_string) + 1, 0);
 	if (x < 0) {
 	    debug(50, 0) ("sendto FD %d: %s\n", cwfd, xstrerror());
 	    debug(50, 0) ("ipcCreate: CHILD: hello write test failed\n");
 	    _exit(1);
 	}
     } else {
-	if (write(cwfd, hello_string, strlen(hello_string)) < 0) {
+	if (write(cwfd, hello_string, strlen(hello_string) + 1) < 0) {
 	    debug(50, 0) ("write FD %d: %s\n", cwfd, xstrerror());
 	    debug(50, 0) ("ipcCreate: CHILD: hello write test failed\n");
 	    _exit(1);
@@ -268,10 +268,14 @@
     close(t1);
     close(t2);
     close(t3);
+    /* Make sure all other filedescriptors are closed */
+    for(x=3;x<SQUID_MAXFD; x++)
+	close(x);
 #if HAVE_SETSID
     setsid();
 #endif
     execvp(prog, args);
+    debug_log = fdopen(2, "a+");
     debug(50, 0) ("ipcCreate: %s: %s\n", prog, xstrerror());
     _exit(1);
     return 0;
Index: squid/src/main.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/main.c,v
retrieving revision 1.1.1.3.4.1.4.1
retrieving revision 1.1.1.3.4.1.4.2
diff -u -r1.1.1.3.4.1.4.1 -r1.1.1.3.4.1.4.2
--- squid/src/main.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.4.1.4.1
+++ squid/src/main.c	3 May 2000 19:22:27 -0000	1.1.1.3.4.1.4.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: main.c,v 1.1.1.3.4.1.4.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: main.c,v 1.1.1.3.4.1.4.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 1     Startup and Main Loop
  * AUTHOR: Harvest Derived
@@ -101,6 +101,7 @@
 	"       -F        Don't serve any requests until store is rebuilt.\n"
 	"       -N        No daemon mode.\n"
 	"       -R        Do not set REUSEADDR on port.\n"
+	"       -S        Double-check swap during rebuild.\n"
 	"       -V        Virtual host httpd-accelerator.\n"
 	"       -X        Force full debugging.\n"
 	"       -Y        Only return UDP_HIT or UDP_MISS_NOFETCH during fast reload.\n",
@@ -377,12 +378,18 @@
 mainRotate(void)
 {
     icmpClose();
+    dnsShutdown();
+    redirectShutdown();
+    authenticateShutdown();
     _db_rotate_log();		/* cache.log */
     storeDirWriteCleanLogs(1);
     storeLogRotate();		/* store.log */
     accessLogRotate();		/* access.log */
     useragentRotateLog();	/* useragent.log */
     icmpOpen();
+    dnsInit();
+    redirectInit();
+    authenticateInit();
 }
 
 static void
@@ -487,9 +494,6 @@
 #endif
 
     if (!configured_once) {
-#if USE_ASYNC_IO
-	aioInit();
-#endif
 	unlinkdInit();
 	urlInitialize();
 	cachemgrInit();
@@ -612,6 +616,7 @@
 #endif
 	memInit();		/* memInit is required for config parsing */
 	eventInit();		/* eventInit() is required for config parsing */
+	storeFsInit();		/* required for config parsing */
 	parse_err = parseConfigFile(ConfigFile);
 
 	if (opt_parse_cfg_only)
@@ -901,21 +906,16 @@
     releaseServerSockets();
     commCloseAllSockets();
     unlinkdClose();
-#if USE_ASYNC_IO
-    aioSync();			/* flush pending object writes / unlinks */
-#endif
+    storeDirSync();		/* Flush pending object writes/unlinks */
     storeDirWriteCleanLogs(0);
     PrintRusage();
     dumpMallocStats();
-#if USE_ASYNC_IO
-    aioSync();			/* flush log writes */
-#endif
+    storeDirSync();		/* Flush log writes */
     storeLogClose();
     accessLogClose();
-#if USE_ASYNC_IO
-    aioSync();			/* flush log close */
-#endif
+    storeDirSync();		/* Flush log close */
 #if PURIFY || XMALLOC_TRACE
+    storeFsDone();
     configFreeMemory();
     storeFreeMemory();
     /*stmemFreeMemory(); */
Index: squid/src/mem.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/mem.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/mem.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/mem.c	3 May 2000 19:22:27 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: mem.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: mem.c,v 1.1.1.3.8.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 13    High Level Memory Pool Management
  * AUTHOR: Harvest Derived
@@ -203,7 +203,6 @@
     memDataInit(MEM_ACL_TIME_DATA, "acl_time_data", sizeof(acl_time_data), 0);
     memDataInit(MEM_ACL_PROXY_AUTH_USER, "acl_proxy_auth_user",
 	sizeof(acl_proxy_auth_user), 0);
-    memDataInit(MEM_AIO_RESULT_T, "aio_result_t", sizeof(aio_result_t), 0);
     memDataInit(MEM_CACHEMGR_PASSWD, "cachemgr_passwd",
 	sizeof(cachemgr_passwd), 0);
 #if USE_CACHE_DIGESTS
@@ -218,7 +217,6 @@
 #if USE_CACHE_DIGESTS
     memDataInit(MEM_DIGEST_FETCH_STATE, "DigestFetchState", sizeof(DigestFetchState), 0);
 #endif
-    memDataInit(MEM_DISK_BUF, "Disk I/O Buffer", DISK_PAGE_SIZE, 200);
     memDataInit(MEM_DLINK_LIST, "dlink_list", sizeof(dlink_list), 10);
     memDataInit(MEM_DLINK_NODE, "dlink_node", sizeof(dlink_node), 10);
     memDataInit(MEM_DNSSERVER_T, "dnsserver_t", sizeof(dnsserver_t), 0);
@@ -264,10 +262,12 @@
     memDataInit(MEM_PEER_DIGEST, "PeerDigest", sizeof(PeerDigest), 0);
     memDataInit(MEM_DIGEST_FETCH_STATE, "DigestFetchState", sizeof(DigestFetchState), 0);
 #endif
+#if USE_ICMP
     memDataInit(MEM_PINGERECHODATA, "pingerEchoData",
 	sizeof(pingerEchoData), 0);
     memDataInit(MEM_PINGERREPLYDATA, "pingerReplyData",
 	sizeof(pingerReplyData), 0);
+#endif
     memDataInit(MEM_PS_STATE, "ps_state", sizeof(ps_state), 0);
     memDataInit(MEM_REFRESH_T, "refresh_t", sizeof(refresh_t), 0);
     memDataInit(MEM_RELIST, "relist", sizeof(relist), 0);
@@ -350,8 +350,3 @@
     memFree(p, MEM_8K_BUF);
 }
 
-void
-memFreeDISK(void *p)
-{
-    memFree(p, MEM_DISK_BUF);
-}
